-- interface for getting IC names

local Main = ListenerAddon
local L = Main.Locale

local g_func

-------------------------------------------------------------------------------
function Main:SetNameResolver( func )
	if g_func then return end -- already have resolver
	g_func = func
end

-------------------------------------------------------------------------------
local function GetCharacterClassColor( guid )
	  
	local _, cls = GetPlayerInfoByGUID( guid )
	if cls and RAID_CLASS_COLORS[cls] then
		local c = RAID_CLASS_COLORS[cls]
		return ("ff%.2x%.2x%.2x"):format(c.r*255, c.g*255, c.b*255)
	end
end

Main.GetCharacterClassColor = GetCharacterClassColor

-------------------------------------------------------------------------------
function Main:GetICName( name, guid )

	if not g_func then
		return name, "", nil, GetCharacterClassColor( guid )
	end
	
	local firstname, lastname, icon, color = g_func( name, guid )
	if color == nil then
		color = GetCharacterClassColor( guid )
	end
	
	return firstname, lastname, icon, color
end
